

function [sig,tau] = get_adaptive_stepsize(x,sig,tau,w_level,filter_name)

	[n,m,t] = size(x);
	
	Kx = zeros(n,m,6);
	

        Kx(:,:,1:5) =  ( cat(3, fgrad_1(x(:,:,1))-x(:,:,2:3) , sym_bgrad_2(x(:,:,2:3)) )) ;

    
        
        nKx = sqrt(sum(sum( Kx(:,:,1).^2 + Kx(:,:,2).^2 + Kx(:,:,3).^2 + Kx(:,:,4).^2 + 2*Kx(:,:,5).^2 )));

        nx = sqrt(sum(sum( 	x(:,:,1).^2 + x(:,:,2).^2 + x(:,:,3).^2 )));
        
                    
    
    %Set |x| / |Kx|
    tmp = (nx/nKx);
    theta = 0.95;
    
    %Check convergence condition
    if sig*tau > tmp^2 %If stepsize is too large
        if theta^(2)*sig*tau < tmp^2 %Check if minimal decrease satisfies condition
            sig = theta*sig;
            tau = theta*tau;
        else                        %If not, decrease further
            sig = tmp;
            tau = tmp;
        end
    end
