

function [lp,hp,lpr,hpr] = get_filters(name)
%Note that, in contrast to the (actuall) JPEG 2000 standard, we use exactly
%the filters as in the JPEG 2000 paper.
%the wavecdf97 that we use for decompression uses scalar multiples of these
%filters

%Filters according to name


if strcmp(name,'CDF') %For real transform
    
    lp = [0.6029490182363579 0.2668641184428723 -0.07822326652898785 -0.01686411844287495 0.02674875741080976];
    hp = [1.115087052456994 -0.5912717631142470 -0.05754352622849957 0.09127176311424948];

    lp = [fliplr(lp(2:end)), lp];
    hp = [fliplr(hp(2:end)), hp];

    lpr = hp .* [-1 1 -1 1 -1 1 -1];
    hpr = lp .* [1 -1 1 -1 1 -1 1 -1 1];

elseif strcmp(name,'LeGall')%For integer transform
    
    lp = [-1/8 2/8 6/8 2/8 -1/8];
    hp = [-1/2 1 -1/2];

    lpr = [1/2 1 1/2];
    hpr = [-1/8 -2/8 6/8 -2/8 -1/8];
    
	
else
    error('Wrong DWT-type');
end
